@ECHO OFF
SETLOCAL
:: Rev 2

PUSHD
COLOR 0A
CLS

REM @@ MUST CHANGE DB_INSTANCES Var @@
REM set the databases instances here. Example: (orcl testdb)
set DB_INSTANCES=(orcl orcl1 orcl2)
ECHO == %DATE%

GOTO :CHECKWRITER

::============
ECHO Restart writer in clean state (and clear memory)
FOR /F %%i in ('oravssw /q') DO (
ECHO Stop %%i
net stop %%i
ECHO.
)
timeout /t 5


FOR /F %%i in ('oravssw /q') DO (
ECHO Start %%i
net start %%i
ECHO.
)
timeout /t 5

:CHECKWRITER
ECHO Please make sure Oracle writer is running and healthy 
ECHO.
ECHO To query writer state ( vssadmin list writers )
ECHO To restart writers ( net stop/start writer )
ECHO.
ECHO Writers:
oravssw /q /status
ECHO.
ECHO Database to be restored: %DB_INSTANCES%
ECHO.
SET /P ANSWER=Do you want to continue to restore db process (Y/N)?
ECHO You chose: %ANSWER%
IF /i {%ANSWER%}=={y} (goto :CHEKRN)
IF /i {%ANSWER%}=={yes} (goto :CHEKRN) 
GOTO :END 


:CHEKRN
::============
ECHO == %TIME%: Starting recovery process...
::============
REM Start in the Quorum usr folder
cd /d "%SYSTEMDRIVE%\Program Files\Quorum\usr"

REM Check to make sure we're on the RN - we don't want to accidentally run this on the PN
IF NOT EXIST  %Systemroot%\System32\Config\System.onqm (
ECHO ERROR: Aborting restore - Please run this on the RN only!
ECHO        Detected %Systemroot%\System32\Config\System.onqm  
ECHO.
goto :END
)

::============
REM Shutdown all database instances
::============
FOR %%i in %DB_INSTANCES% DO (
ECHO.
ECHO == %TIME%: Shutting down database %%i
ECHO Please provide SYS password for database '%%i?'
set ORACLE_SID=%%i
sqlplus SYS as SYSDBA @shutdown.sql
ECHO.
ECHO. ....................................
)
ECHO.

REM Execute Oracle VSS restore
ECHO == %TIME%: Restoring databases - Please be patient...
timeout /t 5

qvss.exe restore
ECHO.

IF %ERRORLEVEL% EQU 0 (
    ECHO "--- Database restored."
) ELSE (
    ECHO.
    ECHO "--- Restore DB filed from qvss.exe!!!"
    ECHO "    Please check event logs on PN and RN!!!"
)

ECHO.
SET /P ANSWER=Do you want to continue to start Databases (Y/N)?
ECHO You chose: %ANSWER%
IF /i {%ANSWER%}=={y} (goto :YES)
IF /i {%ANSWER%}=={yes} (goto :YES) 
GOTO :END 

:YES

::============
REM Open all database instances with resetlogs
::============
FOR %%i in %DB_INSTANCES% DO (
ECHO.
ECHO == %TIME%: Opening database %%i with resetlogs...
ECHO Please provide SYS password for database '%%i'?
set ORACLE_SID=%%i
sqlplus SYS as SYSDBA @open_resetlogs.sql
ECHO.
ECHO. ....................................
)

ENDLOCAL
:END
ECHO == %TIME%: Recovery process ended
POPD
PAUSE
COLOR 07
